<?php

/**
 * liquidacion_anticipo_ces actions.
 *
 * @package    nomina
 * @subpackage liquidacion_anticipo_ces
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class liquidacion_anticipo_cesActions extends sfActions {

    /**
     * Liquidacion Cesantias
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------* Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");




        /**
         * Abrir nueva conexion con la Base de Datos
         */
        $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
        $this->conn->beginTransaction();

        /*
         * Formato de fecha
         */
        //Sql
        $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD" 
EOD;
        //Ejecutar SQL
        CN_TABLE::executeSQL($sql);
        $arrayConstantes = array();

        try {

            /*
             * (SGC-1, ANM-2, SGR-3, CYC-4, COL-5, INCI-6, LOCAL-7)
             */
            $array = sfYaml::load(dirname(__FILE__) . '/../../../config/app-gwt.yml');

            $int = 0;
            foreach ($array as $routeName => $routeData) {
                //echo $routeName . "\n";
                if ('entidad_cliente' == $routeName) {
                    foreach ($routeData as $key => $value) {
                        //echo $value . "\n";
                        if ($key == 'value') {
                            $entidadCliente = $value;
                        }
                    }
                }
                $int++;
            }

            /**
             * Consultar salario minimo
             */
            $salario_minimo = 550000;
            //Sql
            $sql = <<<EOD
(select nvl(valor_mensual, 0) as valor_mensual from no_smdlv where vigencia = extract(year from sysdate))  
EOD;
            //Ejecutar SQL
            $record_smlv = CN_TABLE::executeSQL($sql);

            if (count($record_smlv) > 0) {
                //No se debe redondear - 20130802
//                $salario_minimo = round($record_smlv[0]['valor_mensual'], -3);
                $salario_minimo = round($record_smlv[0]['valor_mensual']);
            }

            /**
             * Cargar tabla constantes
             */
            $text = '$con_';
            //Constantes 
            $sql = <<<EOD
Select cons.*, '$text'|| cons.id_constante as reemplazo from no_constante cons 
EOD;
            //Ejecutar SQL
            $records = CN_TABLE::executeSQL($sql);


            //Agrega a un array todas las constantes
            foreach ($records as $value) {

//                foreach ($value as $key => $value2) {
//                    $this->logMessage($key . " - " . $value2);
//                }

                $arrayConstantes[$value['reemplazo']] = $value;
//                $this->logMessage($value['reemplazo'] . "------------------------" . $arrayConstantes[$value['reemplazo']]);
            }

            /*
             * Anexo de variables del request para reemplazo en constantes
             */
//            $arrayConstantes[''] = '';

            /**
             * Variables de filtro
             */
            //id_periodo
            $id_periodo = $request['id_periodo_filtro'];
            $progress_key = $request['progress_key'] . $request['username'];

            //id_agrup_concepto
            $id_agrup_concepto = $request['id_agrup_concepto'];

            //Funcionario num_doc
            $num_doc = null;
            $whereFuncionarioNumDoc = "";
            if (isset($request['num_doc'])) {
                $num_doc = $request['num_doc'];
                $whereFuncionarioNumDoc = " AND tab0.num_doc = '" . $request['num_doc'] . "'";
            }
            //Funcionario id_tipo_doc 
            $id_tipo_doc = null;
            $whereFuncionarioTipoDoc = "";
            if (isset($request['id_tipo_doc'])) {
                $id_tipo_doc = $request['id_tipo_doc'];
                $whereFuncionarioTipoDoc = " AND tab0.id_tipo_doc = " . $request['id_tipo_doc'];
            }

            /*
             *  Borrar datos anteriores Periodo-Funcionario
             */
            //Sql
            $sql = <<<EOD
DELETE FROM NO_CESANTIA tab0 WHERE tab0.id_periodo = $id_periodo
and tab0.consolidado = 2 
$whereFuncionarioNumDoc $whereFuncionarioTipoDoc 
EOD;
            //Ejecutar SQL
            CN_TABLE::executeSQL($sql);


            /*
             * Traer funcionarios activos a 31 de diciembre del anho que corresponda el periodo
             * Para los funcionarios que se encuentren activos a 31 de diciembre
             */
            //Validacion para fecha de ingreso null - 20140116
            //COL :: No puede liquida personas retiradas el 1 del mes de enero  - 20150130
            //Incidente #7863, si el nombramiento tiene fecha del año actual, revisa si es de continuidad, para ver la fecha del nombramiento anterior - 20180116
            //Debe tomar tambien el primer dia del siguiente mes se agregan variables para validar retiro primer dia mes - 20180126
            //fecha_termina, se coloca que activos a 31 de diciembre segun periodo - 20191216
            //Sql
            $sql = <<<EOD
select distinct
extract(YEAR FROM (select fecha_ini from no_periodo where id_periodo = $id_periodo)) as vig_ini,
1 as per_ini,
extract(YEAR FROM (select fecha_fin from no_periodo where id_periodo = $id_periodo)) as vig_fin,
extract(MONTH FROM (select fecha_fin from no_periodo where id_periodo = $id_periodo)) as per_fin, 
(select ID_ANHOS from NO_PERIODO where ID_PERIODO = $id_periodo) || '-01-01' as FECHA_INI,
TAB0.ID_TIPO_DOC,
TAB0.NUM_DOC,
--TAB0.ID_DP,
--TAB0.ID_ANHOS,
--TAB0.ID_MESES,
--TAB0.PERIODO,
--TAB0.ACTUAL,
--TAB0.ID_EA,
--TAB0.ID_CEN_OP,
nombra.id_nombramiento,
nombra.fecha_nombra,

case 
when extract(year from nombra.fecha_ingreso ) = (select id_anhos from no_periodo where id_periodo = $id_periodo) and nombra.solucion_continuidad = 0 then nombra.fecha_ingreso 
when extract(year from nombra.fecha_ingreso ) = (select id_anhos from no_periodo where id_periodo = $id_periodo) and nombra.solucion_continuidad = 1 
    then 
        case when extract(year from nvl((select max(nom.fecha_ingreso) from no_nombramiento nom where nom.id_tipo_doc = 1 and nom.num_doc = TAB0.NUM_DOC and nom.id_nombramiento != nombra.id_nombramiento ),nombra.fecha_ingreso)) = (select id_anhos from no_periodo where id_periodo = $id_periodo)
              then nvl((select max(nom.fecha_ingreso) from no_nombramiento nom where nom.id_tipo_doc = 1 and nom.num_doc = TAB0.NUM_DOC and nom.id_nombramiento != nombra.id_nombramiento ),nombra.fecha_ingreso)
              else TO_DATE( (select ID_ANHOS from NO_PERIODO where ID_PERIODO = $id_periodo) || '-01-01','yyyy-mm-dd') end
else TO_DATE( (select ID_ANHOS from NO_PERIODO where ID_PERIODO = $id_periodo) || '-01-01','yyyy-mm-dd') end as fecha_ingreso,

case when extract(year from nombra.fecha_termina ) = (select id_anhos from no_periodo where id_periodo = $id_periodo)  and nombra.fecha_retiro is not null 
then nombra.fecha_termina else trunc(last_day( to_date( (select id_anhos from no_periodo where id_periodo = $id_periodo)  || '-' || (select id_meses from no_periodo where id_periodo = $id_periodo), 'yyyy-mm') ) ) end as fecha_termina

from no_estado_func_v tab0

join no_nombramiento_v nombra
on tab0.id_tipo_doc = nombra.id_tipo_doc
and tab0.num_doc = nombra.num_doc

WHERE
TAB0.PERIODO = $id_periodo
$whereFuncionarioNumDoc $whereFuncionarioTipoDoc 
/*
--and tab0.actual = 1
and ( NOMBRA.FECHA_TERMINA is null or NOMBRA.FECHA_TERMINA > TO_DATE( (select ID_ANHOS from NO_PERIODO where ID_PERIODO = $id_periodo)||'-12-31','yyyy-mm-dd') )
*/
and ( nombra.fecha_ingreso < TO_DATE( (select ID_ANHOS from NO_PERIODO where ID_PERIODO = $id_periodo)||'-12-31','yyyy-mm-dd') )                    
and ( tab0.actual = 1 

    or (nombra.estado = 1 or
      ( nombra.estado = 0 
        and nombra.fecha_termina >= trunc(last_day( TO_DATE( (select ID_ANHOS from NO_PERIODO where ID_PERIODO = $id_periodo)||'-12-31','yyyy-mm-dd') ) )
      /*between TO_DATE( (select ID_ANHOS from NO_PERIODO where ID_PERIODO = $id_periodo)||'-01-01','yyyy-mm-dd')
      and trunc(last_day( TO_DATE( (select ID_ANHOS from NO_PERIODO where ID_PERIODO = $id_periodo)||'-12-31','yyyy-mm-dd') ) +1 )*/
      )
    )

)                    
                    
order by
--TAB0.ID_ANHOS,
tab0.id_tipo_doc,
--TAB0.ID_MESES,
tab0.num_doc
EOD;
            //Ejecutar SQL
            $records = CN_TABLE::executeSQL($sql);

            //Validar si hay funcionarios para liquidación
            if (count($records) > 0) {
                $this->logMessage("[liquidacion_anticipo_ces] Validar si hay funcionarios para liquidación.");

                /*
                 * Obtener concep_periodo por agrupacion - Orden a liquidar
                 */
                $sql = <<<EOD
select 
* 
from no_agrup_deta
where id_agrup_concepto = $id_agrup_concepto
order by 
orden,
id_agrup_deta 
EOD;
                //Ejecutar SQL
                $records_agrup = CN_TABLE::executeSQL($sql);
                /*
                 * Por funcionario 
                 */
                $i = 1;
                $nom_conceptos_a_procesar = count($records);

                // Antes de inicar el proceso largo
                $brecha = 1;
                if ($nom_conceptos_a_procesar > 100)
                    $brecha = $nom_conceptos_a_procesar - (0.99 * $nom_conceptos_a_procesar);

                $this->logMessage("[liquidacion_anticipo_ces] nom_conceptos_a_procesar: " . $nom_conceptos_a_procesar);
                foreach ($records as $value) {

                    // Guardar un valor en el proceso largo
                    if ($i % $brecha == 0) {
                        MemcacheHandler::getInstance()->set($progress_key, round(($i / $nom_conceptos_a_procesar) * 100, 0));
                    }

                    $this->logMessage("[liquidacion_anticipo_ces] Existen liquidaciones.");

                    /*
                     * Datos por record
                     */
                    $fecha_ingreso = $value['fecha_ingreso'];
                    $fecha_termina = $value['fecha_termina'];
                    $num_doc = $value['num_doc'];
                    $id_tipo_doc = $value['id_tipo_doc'];
                    $vig_ini = $value['vig_ini'];
                    $per_ini = $value['per_ini'];
                    $vig_fin = $value['vig_fin'];
                    $per_fin = $value['per_fin'];


                    /*
                     * Verificar si para un funcionario cambia la asignacion basica en los ultimos 3 meses
                     * Valida si es por promedio o el ultimo salario pagado - 20140128
                     * Valida el caso de los funcionarios que tienen una novedad de encargo y terminación para la misma fecha - 20150211
                     */
//                    $sql = <<<EOD
//select tab.ult_valor - tab.valor as promedio from(
//
//select 
//SUM( case when LIQNOM.ID_PERIODO  = $id_periodo then round(LIQNOM.VALOR_LIQUIDADO/LIQNOM.NUM_DIAS*30) else 0 end ) as ult_valor,
//round( ( NVL(SUM(LIQNOM.VALOR_LIQUIDADO),0) / SUM(NVL(LIQNOM.NUM_DIAS,0)) ) * 30 )  as VALOR  
//from NO_LIQUIDA_NOMINA LIQNOM  
//join NO_PERIODO PER on PER.ID_PERIODO = LIQNOM.ID_PERIODO 
//where 1 = 1 and PER.ID_ANHOS || LPAD(PER.ID_MESES, 2, '0') 
//between  $vig_ini || LPAD( $per_fin-2, 2, '0')  and $vig_fin || LPAD( $per_fin, 2, '0')  
//and liqnom.num_doc = '$num_doc'  and liqnom.id_tipo_doc = $id_tipo_doc  
//    and liqnom.id_concep_nomina = (select NO_PARAM_CONCEP.ID_CONCEP_BASICA from NO_PARAM_CONCEP)   
//
//)tab
//EOD;


                    $sql = <<<EOD
select tab.ult_valor - round(tab.valor/cant) as promedio from(

    select 
    
    SUM( case when LIQNOM.PERIODO  = $id_periodo then round(LIQNOM.valor) else 0 end )/
    (case when sum( case when LIQNOM.PERIODO  = $id_periodo then 1 else 0 end ) > 0 then sum( case when LIQNOM.PERIODO  = $id_periodo then 1 else 0 end ) else 1 end) as ult_valor,
    round( ( NVL(SUM(LIQNOM.valor),0)  ) )  as VALOR,
    count(LIQNOM.valor) as cant
    
    from no_concepto_periodo LIQNOM  
    join NO_PERIODO PER on PER.ID_PERIODO = LIQNOM.PERIODO 
    where 1 = 1 and PER.ID_ANHOS || LPAD(PER.ID_MESES, 2, '0') 
    between  $vig_ini || LPAD( $per_fin-2, 2, '0')  and $vig_fin || LPAD( $per_fin, 2, '0')  
    and liqnom.num_doc = '$num_doc'  and liqnom.id_tipo_doc = $id_tipo_doc  
        and liqnom.id_concep_nomina = (select NO_PARAM_CONCEP.ID_CONCEP_BASICA from NO_PARAM_CONCEP) 
    and (
        case 
        when LIQNOM.num_dias > 0  then 1 
        when LIQNOM.num_dias = 0  and  liqnom.fecha_desde <= liqnom.fecha_hasta then 1 
        else 0 end
    ) = 1

)tab
EOD;
                    //Ejecutar SQL
                    $records_promedio = CN_TABLE::executeSQL($sql);

                    $promedio = 0;
                    if ($records_promedio[0]['promedio'] != 0) {
                        $promedio = 1;
                    }

                    /*
                     * Se verifica para MIN que revise tambien concepto 55 prima - 20210126
                     */
                    if ($entidadCliente == 5 && $promedio == 0) {
                        $sql = <<<EOD
select tab.ult_valor - round(tab.valor/cant) as promedio from(

    select 
    
    SUM( case when LIQNOM.PERIODO  = $id_periodo then round(LIQNOM.valor) else 0 end )/
    (case when sum( case when LIQNOM.PERIODO  = $id_periodo then 1 else 0 end ) > 0 then sum( case when LIQNOM.PERIODO  = $id_periodo then 1 else 0 end ) else 1 end) as ult_valor,
    round( ( NVL(SUM(LIQNOM.valor),0)  ) )  as VALOR,
    count(LIQNOM.valor) as cant
    
    from no_concepto_periodo LIQNOM  
    join NO_PERIODO PER on PER.ID_PERIODO = LIQNOM.PERIODO 
    where 1 = 1 and PER.ID_ANHOS || LPAD(PER.ID_MESES, 2, '0') 
    between  $vig_ini || LPAD( $per_fin-2, 2, '0')  and $vig_fin || LPAD( $per_fin, 2, '0')  
    and liqnom.num_doc = '$num_doc'  and liqnom.id_tipo_doc = $id_tipo_doc  
        and liqnom.id_concep_nomina = (55) 
    and (
        case 
        when LIQNOM.num_dias > 0  then 1 
        when LIQNOM.num_dias = 0  and  liqnom.fecha_desde <= liqnom.fecha_hasta then 1 
        else 0 end
    ) = 1

)tab
EOD;
                        //Ejecutar SQL
                        $records_promedio = CN_TABLE::executeSQL($sql);

                        if ($records_promedio[0]['promedio'] != 0) {
                            $promedio = 1;
                        }
                    }


                    /**
                     * Recorrer Agrupaciones
                     */
                    foreach ($records_agrup as $value_agrup) {

                        /*
                         * Variables agrup_concep
                         */
                        $id_concep_nomina = $value_agrup['id_concep_nomina'];
                        $caracter = $value_agrup['tipo_valor'];

                        /*
                         * Calcular los dias a liquidar (ausencias no afectan antiguedad)
                         */
                        $dias_liq = $this->diasLiquidar($id_periodo, $num_doc, $id_tipo_doc, $fecha_ingreso, $fecha_termina, $value, $id_concep_nomina);
                        $this->logMessage("[liquidacion_anticipo_ces] Dias de Liquidación: " . $dias_liq);


                        /*
                         * Tag_retro para cuando es retroactivo, para retencion tiene encuenta todo el mes con lo del retroactivo - 20150610
                         * Se pone Tag_retro en 1 para que tenga encuenta el retro - 20160112
                         */
                        //SQL Record a liquidar
                        $sql = <<<EOD
select
$salario_minimo as salario_minimo,
1 as tag,
1 as tg_retro,
$promedio as promedio,
$vig_ini as vig_ini,
$per_ini as per_ini,
$vig_fin as vig_fin,
$per_fin as per_fin,
$dias_liq as dias_liq,
'$caracter' as caracter,
nvl('$fecha_ingreso', '') as fecha_ingreso,
nvl('$fecha_termina', '') as fecha_termina,
$dias_liq as num_dias,
null as porcentaje,
$num_doc as num_doc,
$id_tipo_doc as id_tipo_doc,
$id_periodo as id_periodo,
$id_periodo as periodo,
$id_concep_nomina as id_concep_nomina
from dual     
EOD;
                        //Ejecutar SQL
                        $recordsLiq = CN_TABLE::executeSQL($sql);

                        /*
                         * Validar registro
                         */
                        if (count($recordsLiq) > 0) {

                            //Liquidar concepto
                            $record_liq = $recordsLiq[0];
                            $this->liquidar($id_periodo, $num_doc, $id_tipo_doc, $id_concep_nomina, $record_liq, $arrayConstantes);
                        } else {
                            /*
                             * Mensaje de error
                             */
                            $mensajeError = "No hay registro para liquidación de Anticipo Cesantias. Concepto: " . $id_concep_nomina;

//                            $this->status = 1;
//                            $this->list_data = array();
//                            $this->mensajeError = $mensajeError;
                            $this->logMessage("[liquidacion_anticipo_ces] " . $mensajeError);
                        }
                    }
//                    die();
                    $i++;
                }
                MemcacheHandler::getInstance()->set($progress_key, 100);

                /*
                 * COMMIT DE TODAS LAS TRANSACCIONES
                 */
                $this->conn->commit();
                $this->status = 0;
                $this->list_data = array();
                $this->logMessage("[liquidacion_anticipo_ces] Liquidación exitosa.");
            } else {
                MemcacheHandler::getInstance()->set($progress_key, 100);

                /*
                 * ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                 */
                $this->conn->rollback();

                /*
                 * Mensaje de error
                 */
                $mensajeError = "No hay funcionarios para liquidación.";

                $this->status = 1;
                $this->list_data = array();
                $this->mensajeError = $mensajeError;
                $this->logMessage("[liquidacion_anticipo_ces] " . $mensajeError);
            }
        } catch (Exception $e) {
            MemcacheHandler::getInstance()->set($progress_key, 100);

            /*
             * ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
             */
            $this->conn->rollback();
            $this->status = 1;
            $this->mensajeError = "[liquidacion_anticipo_ces] Ocurrio un error: " . $e->getMessage();
            $this->list_data = array();
            $this->logMessage("[liquidacion_anticipo_ces] ERROR!");
            $this->logMessage($e->getMessage());
        }
    }

    /**
     * Calcular los dias a liquidar (ausencias no afectan antiguedad) 
     * @param type $id_periodo
     * @param type $num_doc
     * @param type $id_tipo_doc
     * @param type $fecha_ingreso
     * @param type $fecha_termina
     * @param type $record
     * @param type $id_concep_nomina
     */
    private function diasLiquidar($id_periodo, $num_doc, $id_tipo_doc, $fecha_ingreso, $fecha_termina, $record, $id_concep_nomina) {

        /*
         * Variables de calculo
         */
        $dias = 0;
        $dias_kardex = 0;
        $fecha_fin = $fecha_termina;
        $aplica = 0;


        //CESANTIAS ANUALES - Enero 1 a la fecha de retiro
        //Sql
        $sql = <<<EOD
select case when $id_concep_nomina in ( select distinct id_concep_nomina from no_agrup_deta where id_agrup_concepto = (select no_param_concep.id_agrup_cesanticipo from no_param_concep) ) 
    then 1 else 0 end as aplica from dual  
EOD;
        //Ejecutar SQL
        $records_aplica = CN_TABLE::executeSQL($sql);

        if (count($records_aplica) > 0) {
            $aplica = $records_aplica[0]['aplica'];
        }

        /*
         * ($id_concep_nomina == 20 || $id_concep_nomina == 426 || $id_concep_nomina == 257 || $id_concep_nomina == 262 || $id_concep_nomina == 231)  
         * Se cambian id por la agrupacion de cesanu de NO_PARAM_CONCEP - 20150311
         */
        if ($aplica == 1) {

            $fecha_ini = $record['fecha_ini'];

            $date1 = new DateTime($fecha_ini);
            $date2 = new DateTime($fecha_ingreso);

            /*
             * Si la fecha de ingreso del funcionario es posterior a la fecha 1 de enero del mismo anho, 
             * debe tomar solo desde la fecha de ingreso del funcionario
             */
            if ($date2 > $date1) {
                $dias = CN_TABLE::diasEntreFechas($fecha_ingreso, $fecha_termina, false);
                $fecha_ini = $fecha_ingreso;
            } else {
                $dias = CN_TABLE::diasEntreFechas($fecha_ini, $fecha_termina, false);
            }
//            $dias = $dias - 1;
        } else {
            $this->logMessage("[liquidacion_anticipo_ces] Id de concepto sin identificar. id: " . $id_concep_nomina);
//            $dias = 360;
        }


        /*
         * Claculo de dias de novedad de kardex que afectan antiguedad
         * 
         * Se restan dias de kardex del mes unicamente - 20130627
         * Verificacion del mes de periodo a liqudiar cesantias - 20130826
         */

        //Sql
        $sql = <<<EOD
select nvl(sum(dias_ka),0) as dias from(
  select 
  dias_habiles_cant( to_date(novka.fecha_ini,'yyyy-mm-dd'), to_date(novka.fecha_fin,'yyyy-mm-dd') ) as dias,
  DIAS_RANGO_ANHO_SINTREINTAYUNO( NOVKA.FECHA_INI, NOVKA.FECHA_FIN, (select extract(year from fecha_ini) from no_periodo where id_periodo =  $id_periodo) ) as DIAS_KA,
  novka.* ,
  tipnov.afecta_antigu,
  tipnov.afecta_alimen
  from no_novedad_kardex novka
  join no_tip_nov_ka tipnov 
  on novka.id_tip_nov_ka = tipnov.id_tip_nov_ka
  and tipnov.afecta_antigu = 1 
  and novka.estado = 1
  where
    (
        novka.fecha_ini between to_date('$fecha_ini','yyyy-mm-dd') and to_date('$fecha_fin','yyyy-mm-dd')
        or 
        NOVKA.FECHA_FIN between TO_DATE('$fecha_ini','yyyy-mm-dd') and TO_DATE('$fecha_fin','yyyy-mm-dd')
        
        or
        
        TO_DATE('$fecha_ini','yyyy-mm-dd') between novka.fecha_ini and NOVKA.FECHA_FIN
        or 
        TO_DATE('$fecha_fin','yyyy-mm-dd') between novka.fecha_ini and NOVKA.FECHA_FIN
    )
    AND novka.num_doc = '$num_doc'
    AND novka.id_tipo_doc = $id_tipo_doc
) 
EOD;
        //Ejecutar SQL
        $recordsKa = CN_TABLE::executeSQL($sql);

        $dias_kardex = $recordsKa[0]['dias'];


        /**
         * Calculo de dias
         */
        $this->logMessage("[liquidacion_anticipo_ces] " . $dias . " - " . $dias_kardex);
        return $dias - $dias_kardex;


        /*
         * Variables de calculo
         */
//        $dias_calc = 0;
//        $dias_kardex = 0;
//
//        /*
//         * Calculo de dias diferencia
//         */
//        //Sql
//        $sql = <<<EOD
//select 
//to_date(fecha_termina, 'yyyy-mm-dd') - to_date(fecha_ingreso, 'yyyy-mm-dd') + 1 as dias,
//to_date(fecha_termina, 'yyyy-mm-dd') as fecha_termina,
//to_date(fecha_ingreso, 'yyyy-mm-dd') as fecha_ingreso
//from (
//select
//nvl('$fecha_ingreso',to_date( per.id_anhos || '-' || per.id_meses || '-01', 'yyyy-mm-dd') ) as fecha_ingreso,
//nvl('$fecha_termina',trunc(last_day( to_date( per.id_anhos || '-' || per.id_meses, 'yyyy-mm') ) ) ) as fecha_termina
//from no_periodo per
//where 
//per.id_periodo = $id_periodo
//)
//EOD;
//        //Ejecutar SQL
//        $records = CN_TABLE::executeSQL($sql);
//
//        if (count($records) > 0) {
//            $this->logMessage("[liquidacion_anticipo_ces] Dias de diferencia: " . $records[0]['dias']);
//            $dias_calc = $records[0]['dias'];
//
//
//            /*
//             * Claculo de dias de novedad de kardex que afectan antiguedad
//             */
//            $fecha_ini = $records[0]['fecha_ingreso'];
//            $fecha_fin = $records[0]['fecha_termina'];
//            //Sql
//            $sql = <<<EOD
//select nvl(sum(dias),0) as dias from(
//  select 
//  dias_habiles_cant( to_date(novka.fecha_ini,'yyyy-mm-dd'), to_date(novka.fecha_fin,'yyyy-mm-dd') ) as dias,
//  novka.* ,
//  tipnov.afecta_antigu,
//  tipnov.afecta_alimen
//  from no_novedad_kardex novka
//  join no_tip_nov_ka tipnov 
//  on novka.id_tip_nov_ka = tipnov.id_tip_nov_ka
//  and tipnov.afecta_antigu = 0 
//  where
//    (
//        novka.fecha_ini between to_date('$fecha_ini','yyyy-mm-dd') and to_date('$fecha_fin','yyyy-mm-dd')
//        or novka.fecha_fin between to_date('$fecha_ini','yyyy-mm-dd') and to_date('$fecha_fin','yyyy-mm-dd')
//    )
//    AND novka.num_doc = '$num_doc'
//    AND novka.id_tipo_doc = $id_tipo_doc
//) 
//EOD;
//            //Ejecutar SQL
//            $recordsKa = CN_TABLE::executeSQL($sql);
//
//            $dias_kardex = $recordsKa[0]['dias'];
//        }
//
//
//        /**
//         * Calculo de dias de novedad kardex
//         */
//        $this->logMessage("[liquidacion_anticipo_ces] " . $dias_calc . " - " . $dias_kardex);
//
//        if (($dias_calc - $dias_kardex) > 30) {
//            return 30;
//        } else {
//            return $dias_calc - $dias_kardex;
//        }
    }

    /**
     * Procesa la liquidacion para el periodo, funcionario y concepto nomina
     * @param type $id_periodo
     * @param type $num_doc
     * @param type $id_tipo_doc
     * @param type $id_concep_nomina
     * @param type $record_liq
     * @param type $arrayConstantes
     */
    private function liquidar($id_periodo, $num_doc, $id_tipo_doc, $id_concep_nomina, $record_liq, $arrayConstantes) {
        $this->logMessage("[liquidacion_anticipo_ces] Liquidar: periodo " . $id_periodo .
                " - funcionario " . $num_doc . " - concepto nomina " . $id_concep_nomina);

        /**
         * Varibles
         */
        $arrayParametros = array();
        $valor_liquidado = 0;
        $fecha_ingreso = $record_liq['fecha_ingreso'];
        $fecha_termina = $record_liq['fecha_termina'];
        $num_dias = $record_liq['num_dias'];
        $vig_fin = $record_liq['vig_fin'];

        /*
         * Valor Base y porcentaje
         */
        $porcentaje = 'null';
        $valor_base = 'null';

        /*
         *  Cargar fórmulas por concepto
         */
        //Sql
        $sql = <<<EOD
Select * from no_formula WHERE id_concep_nomina = $id_concep_nomina 
EOD;
        //Ejecutar SQL
        $records = CN_TABLE::executeSQL($sql);

        /*
         * Valida si posee formula el concepto
         */
        if (count($records) > 0) {
            $this->logMessage("[liquidacion_anticipo_ces] Entro a calcular Formula.");

            foreach ($records as $value) {


                /**
                 * Se crea tabla para guardar el valor promedio y tomarlo de hay - 20160208
                 */
                //Sql
                $sql = <<<EOD
select 
id_liquida_promedio,
id_anhos,
id_tipo_doc,
num_doc,
id_concep_nomina,
caracter,
valor_promedio
from no_liquida_promedio
where id_anhos = $vig_fin
and id_tipo_doc = $id_tipo_doc
and num_doc = '$num_doc'
and caracter = 'P'
--and id_concep_nomina = $id_concep_nomina    
EOD;
                $rec_promedio = CN_TABLE::executeSQL($sql);
                if (count($rec_promedio) > 0) {
                    //se adiciona un nuevo campo de formula para completar la retencion que es muy grande el proceso - 20210415::LAVILA
                    $formula = $value['formula'] . $value['formula_adic'];
                    foreach ($rec_promedio as $rec_prom) {
                        $id_concep_nomina_prom = $rec_prom['id_concep_nomina'];
                        $formula = str_replace('{P' . $id_concep_nomina_prom . '}', '{Q' . $id_concep_nomina_prom . '}', $formula);
                    }
                } else {
                    //se adiciona un nuevo campo de formula para completar la retencion que es muy grande el proceso - 20210415::LAVILA
                    $formula = $value['formula'] . $value['formula_adic'];
                }

                $this->logMessage("[liquidacion_anticipo_ces] Formula Inicial: " . $formula);


                /*
                 *  Buscar las constantes, variables, fórmulas(parametros) y agrupaciones que use la fórmula
                 */
                //Reemplazo de constantes            
                $formula = $this->reemplazoConstante($formula, $arrayConstantes);
                $this->logMessage("[liquidacion_anticipo_ces] Formula Constante: " . $formula);

                /*
                 * Reemplaza en la consulta los filtros y valores del SQL, que vienen en el record
                 * Ejemplo: select raz_soc from id_cia where id_cia = $id_cia
                 * Reemplaza $id_cia por el valor en el record
                 */
                if ($record_liq['porcentaje'] == '' || $record_liq['porcentaje'] == null) {
                    $record_liq['porcentaje'] = 0;
                }
                $formula = CN_TABLE::reemplazoConsulta($formula, $record_liq);
                $this->logMessage("[liquidacion_anticipo_ces] Formula consulta los filtros: " . $formula);

                /*
                 * Cambio en la formula de A por (C1+C2)
                 */
                $vars = array();

                CN_TABLE::getVarsInFormula($vars, $formula);

//        var_dump($vars);

                foreach ($vars as $var) {
                    if (substr($var, 0, 1) == 'A') {
                        /*
                         * Cambio de A1 por relacion con los conceptos C1
                         * Ejemplo: 'A1' => '0'
                         */
                        $agrup = $this->reemplazoAgrupacion(substr($var, 1));
                        $this->logMessage("[liquidacion_anticipo_ces] Agrupacion: " . $agrup);

                        $formula = str_replace('{' . $var . '}', $agrup, $formula);
                    }
                }
                $this->logMessage("[liquidacion_anticipo_ces] Formula parametrosFormula y reemplazoAgrupacion: " . $formula);


                /*
                 * Parser de la formula para obtener parametros(variables)
                 * Ejemplo: 'A1' => '0',
                 * 'C1' => '0'
                 */
                $arrayParametros = $this->parametrosFormula($formula);


                /*
                 * Obtener resultados de los parametros(variables)
                 * Ejemplo: $arrayParametros = array(
                 * 'C1' => '0',
                 * 'C2' => '0'
                 * );
                 */
                $arrayParametros = $this->resultadoParametros($arrayParametros, $record_liq);


                /*
                 * Reemplazo de parametros(variables) a la formula
                 * Ejemplo: $arrayParametros = array(
                 * 'C1' => '1100',
                 * 'C2' => '55'
                 * );
                 */
                $formula = $this->reemplazoParametros($formula, $arrayParametros);
                $this->logMessage("[liquidacion_anticipo_ces] Formula Final: " . $formula);


                /*
                 * Ejecutar fórmula
                 * Ejemplo: ( 0 == 0 ? {C1} * $porcentaje : false )
                 * Retorna false  si no cumple con la condicion
                 */
                $formula = str_replace('{', ' ', $formula);
                $formula = str_replace('}', ' ', $formula);
                $result = CN_TABLE::aplicarEval($formula);


                /*
                 * No cumple con la condicion
                 */
//                if ($result === false) {
                if ($result == '-9999' || $result == -9999) {
                    $this->logMessage("[liquidacion_anticipo_ces] Formula No cumple con la condicion: " . $formula);
                    $result = 0;
                }


                /*
                 * Acumulan resultados de liquidacion
                 */
                $valor_liquidado += $result;
                $this->logMessage("[liquidacion_anticipo_ces] Acumulan resultados de liquidacion: " . $result);
                /*
                 * Si es por porcentaje
                 */
                if ($record_liq['porcentaje'] != '' || $record_liq['porcentaje'] != null) {
                    /*
                     * Tipo de formula
                     * V - Valor base 
                     * R - Valor restado 
                     * F - Valor de la fórmula (Uso normal)
                     */
                    if ($value['cod_tipo'] == 'V') {
                        $this->logMessage("[liquidacion_anticipo_ces] Formula CodTipo: " . $value['cod_tipo']);

                        /*
                         * Valor Base y porcentaje
                         */
                        $porcentaje = $record_liq['porcentaje'];
                        $valor_base = ($result * 100) / $record_liq['porcentaje'];
                    }
                }
            }
        } else {

            /**
             * Logica de N
             */
            if ($record_liq['caracter'] == 'N') {
                $this->logMessage("[liquidacion_anticipo_ces] Logica de N - Concepto: " . $id_concep_nomina);

                /*
                 * Resta % (se puede para el valor) 
                 */
                //sumar devengados
                //Sql
                $sql = <<<EOD
select 
nvl(sum(liqnom.valor_liquidado),0) as valor_liquidado  
from no_liquida_nomina liqnom
join no_concep_nomina connom
on liqnom.id_concep_nomina = connom.id_concep_nomina
and connom.operador = 1
where
liqnom.id_periodo = $id_periodo
and liqnom.id_tipo_doc = $id_tipo_doc
and liqnom.num_doc = '$num_doc' 
EOD;
                //Ejecutar SQL
                $records_deveng = CN_TABLE::executeSQL($sql);

                if (count($records_deveng) > 0) {

                    $devengado = $records_deveng[0]['valor_liquidado'];

                    //obtener porcentaje de max_ded_noley
                    $devengado_por = ($devengado * $max_ded_noley) / 100;

                    /*
                     * Si es por porcentaje
                     */
                    if ($record_liq['porcentaje'] != '' || $record_liq['porcentaje'] != null) {

                        $valor_logica_n = (0 * $record_liq['porcentaje']) / 100;
                    } else {
                        $valor_logica_n = $record_liq['valor'];
                    }

                    //Validar resta - operar
                    if (($devengado_por - $valor_logica_n - $valor_sumatoria_logica_n) <= 0) {

                        $valor_liquidado = $valor_logica_n;
                        $valor_sumatoria_logica_n += $valor_liquidado;
                    } else {

                        $valor_liquidado = 0;
                    }
                } else {

                    $this->logMessage("[liquidacion_anticipo_ces] No hay valor devengados.");
                    $valor_liquidado = 0;
                }
            } else {
                /*
                 * La liquidación se hacer por 2 espacios temporales:
                 *
                 * - Mensual
                 * En cuyo caso, todos los meses tienen una duración de 30 días
                 * - Por días calendario
                 * En cuyo caso se hace por la cantidad de días especificada en no_concepto_periodo.num_dias
                 * 
                 * Esta especificación, si se hace mensual o usando los días, lo especifica la variable no_concep_nomina.dias_calendario
                 * 
                 * Si se hace una interrupción en un concepto, digamos algún cargo temporal, debe liquidarse el valor del concepto asÍ: 
                 * Ejemplo: $valor = ($valor_liquidado_concepto_mes/30)*$num_dias
                 */

                /*
                 * Si es por porcentaje
                 */
                if ($record_liq['porcentaje'] != '' || $record_liq['porcentaje'] != null) {
                    $this->logMessage("[liquidacion_anticipo_ces] Calcular porcentaje - " . $record_liq['porcentaje']);


                    //Sql
                    $sql = <<<EOD
select * from no_liquida_nomina 
where id_concep_nomina = (select id_concep_basica from no_param_concep where id_param_concep = 1)
and id_periodo = $id_periodo
and id_tipo_doc = $id_tipo_doc
and num_doc = '$num_doc' 
EOD;
                    //Ejecutar SQL
                    $records = CN_TABLE::executeSQL($sql);

                    if (count($records) <= 0) {
                        $records[0]['valor_liquidado'] = 0;
                    }

                    //Resultado del calculo de porcentaje
                    $result = ($records[0]['valor_liquidado'] * $record_liq['porcentaje']) / 100;

                    /*
                     * Valor Base y porcentaje
                     */
                    $porcentaje = $record_liq['porcentaje'];
                    $valor_base = $records[0]['valor_liquidado'];
                } else {
                    $this->logMessage("[liquidacion_anticipo_ces] Calcular valor - " . $record_liq['valor']);

                    if (!is_null($record_liq['num_dias'])) {

                        /*
                         * usa_dias_calen
                         */
                        if ($record_liq['usa_dias_calen'] == 0) { //Mensual
                            $num_dias = 30;
                            $num_dias = $record_liq['num_dias']; // ? Revisar
                        } else { //Por días calendario
                            $num_dias = $record_liq['num_dias'];
                        }

                        $result = ($record_liq['valor'] / 30) * $num_dias;
                    } else {
                        $num_dias = 'null';
                        $result = $record_liq['valor'];
                    }
                }

                $valor_liquidado += $result;
            }
        }

        /**
         * Registro de liquida nomina por concepto 
         */
        /*
         * Valida creacion de registro
         */
        if ($valor_liquidado > 0) {

            $this->logMessage("[liquidacion_anticipo_ces] El valor liquidado es: " . $valor_liquidado);


            $vig_ini = $record_liq['vig_ini'];
            $per_ini = $record_liq['per_ini'];
            $vig_fin = $record_liq['vig_fin'];
            $per_fin = $record_liq['per_fin'];

            /*
             * Obtener registros de consulta
             * Se cambian id (425, 256, 230, 261) por el concepto de la agrupacion de ces mensual parametrizado en NO_PARAM_CONCEP  - 20150311
             * Se coloca relacion a nombramiento, para filtro segun ingreso y solucion_continuidad - 20170206
             */
            $sql = <<<EOD
select  
NVL( 
(
select NVL(SUM(LIQNOM.VALOR_LIQUIDADO),0) as VALOR  
from NO_CESANTIA LIQNOM  join NO_PERIODO PER on PER.ID_PERIODO = LIQNOM.ID_PERIODO 
left join no_nombramiento_v nom on nom.id_tipo_doc = liqnom.id_tipo_doc and nom.num_doc = liqnom.num_doc 
left join no_periodo per2 on per2.id_periodo = nom.id_periodo 
where    1 = 1 and PER.ID_ANHOS || LPAD(PER.ID_MESES, 2, '0') 
between  $vig_ini || LPAD( $per_ini, 2, '0')  and $vig_fin || LPAD( $per_fin, 2, '0')  
and LIQNOM.NUM_DOC = '$num_doc'  and LIQNOM.ID_TIPO_DOC = $id_tipo_doc  
    and LIQNOM.ID_CONCEP_NOMINA in ( select distinct id_concep_nomina from no_agrup_deta where id_agrup_concepto = (select id_agrup_cesmen from no_param_concep) )
    and( nom.solucion_continuidad = 1 or ( nom.solucion_continuidad = 0 and per.id_anhos || lpad(per.id_meses, 2, '0') >= per2.id_anhos || lpad(per2.id_meses, 2, '0') ) )
)
, 0) as valor_aplica

from no_periodo_v per

where 
per.id_periodo = $id_periodo     
EOD;

            /*
             * ejecuta y obtiene el resultado del sql
             */

            $resultado_ajuste = CN_TABLE::executeSQL($sql);

            $valor_consolidado = $valor_liquidado;
            $valor_aplicado = $resultado_ajuste[0]['valor_aplica'];

            $valor_ajuste = round($valor_consolidado) - $valor_aplicado;

            $valor_liquidado = 0;


            /*
             * Crear nueva liquidación
             * 
             * Asignar valores encontrados en persona
             */
            //insert into no_cesantia (id_cesantia,id_periodo,id_tipo_doc,num_doc,id_concep_nomina,
            //valor_liquidado,num_dias,fecha_ingreso,fecha_termina,valor_base) 
            //values ('1','43','1','1015408219','425','100','1',null,null,null);
            //Sql
            $sql = <<<EOD
insert into no_cesantia (id_periodo,id_tipo_doc,num_doc,id_concep_nomina,
valor_liquidado,num_dias,fecha_ingreso,fecha_termina,valor_base,
valor_consolidado, valor_aplicado, valor_ajuste, consolidado)  
values ($id_periodo,$id_tipo_doc,'$num_doc', $id_concep_nomina,
            $valor_liquidado,$num_dias, 
                to_date('$fecha_ingreso','yyyy-mm-dd'), to_date('$fecha_termina','yyyy-mm-dd'), null,
                    round($valor_consolidado), round($valor_aplicado), round($valor_ajuste), 2 )   
EOD;
            //Ejecutar SQL
            CN_TABLE::executeSQL($sql);
        } else {

            $this->logMessage("[liquidacion_anticipo_ces] El valor_liquidado es menor a cero. Valor: " . $valor_liquidado);
        }
    }

    /**
     * Reemplaza en la formula las constantes por valores de la tabla NO_CONSTANTE
     * Ejemplo: $con_1
     * @param type $formula
     * @param type $arrayConstantes
     */
    private function reemplazoConstante($formula, $arrayConstantes) {

        /*
         * Recorrer array de Constantes
         */
        foreach ($arrayConstantes as $key => $value) {

            $formula = str_replace($key, $value['valor'], $formula);
        }

        return $formula;
    }

    /**
     * Reemplaza los parametros(variables) a la formula
     * Ejemplo: $key: C1 / $value: valor - 2+5
     * @param type $formula
     * @param type $arrayParametros
     */
    private function reemplazoParametros($formula, $arrayParametros) {

        /*
         * Recorrer array de Parametros
         */
        foreach ($arrayParametros as $key => $value) {

            $formula = str_replace('{' . $key . '}', $value, $formula);
        }

        return $formula;
    }

    /**
     * Obtener resultados de los parametros(variables)
     * Ejemplo: 'C1' => '0'
     * @param type $arrayParametros
     * @param type $record_liq
     */
    private function resultadoParametros($arrayParametros, $record_liq) {

        /*
         * Recorrer array de Parametros
         */
        foreach ($arrayParametros as $key => $value) {

            //Sacar caracter y numero(id_concep_nomina) para consulta
            $caracter = substr($key, 0, 1);
            $id_concep_nomina = substr($key, 1);
            $this->logMessage("[liquidacion_anticipo_ces] Caracter: " . $caracter . ", numero: " . $id_concep_nomina);

            /*
             * Obtener consulta por caracter
             */
            //Sql
            $sql = <<<EOD
select * from NO_CONSULTA where caracter = '$caracter' 
EOD;
            //Ejecutar SQL
            $record = CN_TABLE::executeSQL($sql);

            //Validar registros SQL
            if (count($record) > 0) {

                $consulta = $record[0]['consulta'];

                //Reemplazo de id_concep_nomina
                $consulta = str_replace('$id_concep_nomina', $id_concep_nomina, $consulta);

                /*
                 * Reemplaza en la consulta los filtros y valores del SQL, que vienen en el record
                 * Ejemplo: select raz_soc from id_cia where id_cia = $id_cia
                 * Reemplaza $id_cia por el valor en el record
                 */
                $consulta = CN_TABLE::reemplazoConsulta($consulta, $record_liq);

                /*
                 * Ejecutar SQL de consulta
                 */
                //Sql
                $sql = <<<EOD
$consulta  
EOD;
                //Ejecutar SQL
                $record = CN_TABLE::executeSQL($sql);

                //Validar registros SQL
                if (count($record) > 0) {
                    $valor = $record[0]['valor'];
                } else {
                    $valor = 0;
                }
            } else {
                $valor = 0;
            }

            $arrayParametros[$key] = $valor;
        }

        return $arrayParametros;
    }

    /**
     * Parser de la formula para obtener parametros(variables)
     * Ejemplo: 'C1' => '0'
     * @param type $formula
     * @param type $arrayParametros
     */
    private function parametrosFormula($formula) {

        $vars = array();

        CN_TABLE::getVarsInFormula($vars, $formula);

        foreach ($vars as $var) {
            $arrayParametros[$var] = 0;
        }

//        var_dump($arrayParametros);
//        exit();
//        $arrayParametros = array(
//            'C1' => '0',
//            'C2' => '0',
//            'T1' => '0',
//            'A1' => '0'
//        );

        return $arrayParametros;
    }

    /**
     * Reemplaza las agrupaciones por los parametros(variables)
     * Ejemplo: A1 -> (+C1-C2-T1)
     * @param type $id_agrup_var
     */
    private function reemplazoAgrupacion($id_agrup_var) {

        $agrup = '( ';

        /*
         * Ejecutar SQL de agrupciones
         */
        //Sql
        $sql = <<<EOD
select 
agru.*,
agru.tipo_valor as caracter
from
no_agrup_deta agru
where agru.id_agrup_concepto = $id_agrup_var  
EOD;
        //Ejecutar SQL
        $records = CN_TABLE::executeSQL($sql);

        /*
         * Recorrer registros 
         */
        foreach ($records as $value) {

            $operador = ($value['operador'] == 1 ? '+' : '-');

            //Concatenar todas las agrupaciones
            $agrup .= $operador . '{' . $value['caracter'] . $value['id_concep_nomina'] . '}';
        }

        $agrup .= ' )';

        return $agrup;
    }

}
